/*=============================================================================
    Phoenix v1.2
    Copyright (c) 2004 Angus Leeming

    Use, modification and distribution is subject to the Boost Software
    License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
    http://www.boost.org/LICENSE_1_0.txt)
==============================================================================*/
#include "stl_container_traits.hpp"

#include <deque>
#include <list>
#include <map>
#include <queue>
#include <vector>
#include <iostream>

int main()
{
    typedef std::deque<int> DequeType;
    typedef std::list<int> ListType;
    typedef std::map<int, int> MapType;
    typedef std::multimap<int, int> MultimapType;
    typedef std::queue<int> QueueType;
    typedef std::vector<int> VecType;

    std::cout << "Is deque?\n"
              << "\tstd::deque<int>: "
              << phoenix::is_std_deque<DequeType>::value << '\n'
              << "\tstd::list<int>: "
              << phoenix::is_std_deque<ListType>::value << '\n'
              << "\tstd::map<int, int>: "
              << phoenix::is_std_deque<MapType>::value << '\n'
              << "\tstd::multimap<int, int>: "
              << phoenix::is_std_deque<MultimapType>::value << '\n'
              << "\tstd::queue<int>: "
              << phoenix::is_std_deque<QueueType>::value << '\n'
              << "\tstd::vec<int>: "
              << phoenix::is_std_deque<VecType>::value << '\n';

    std::cout << "Is list?\n"
              << "\tstd::deque<int>: "
              << phoenix::is_std_list<DequeType>::value << '\n'
              << "\tstd::list<int>: "
              << phoenix::is_std_list<ListType>::value << '\n'
              << "\tstd::map<int, int>: "
              << phoenix::is_std_list<MapType>::value << '\n'
              << "\tstd::multimap<int, int>: "
              << phoenix::is_std_list<MultimapType>::value << '\n'
              << "\tstd::queue<int>: "
              << phoenix::is_std_list<QueueType>::value << '\n'
              << "\tstd::vec<int>: "
              << phoenix::is_std_list<VecType>::value << '\n';

    std::cout << "Is map?\n"
              << "\tstd::deque<int>: "
              << phoenix::is_std_map<DequeType>::value << '\n'
              << "\tstd::list<int>: "
              << phoenix::is_std_map<ListType>::value << '\n'
              << "\tstd::map<int, int>: "
              << phoenix::is_std_map<MapType>::value << '\n'
              << "\tstd::multimap<int, int>: "
              << phoenix::is_std_map<MultimapType>::value << '\n'
              << "\tstd::queue<int>: "
              << phoenix::is_std_map<QueueType>::value << '\n'
              << "\tstd::vec<int>: "
              << phoenix::is_std_map<VecType>::value << '\n';

    std::cout << "Is multimap?\n"
              << "\tstd::deque<int>: "
              << phoenix::is_std_multimap<DequeType>::value << '\n'
              << "\tstd::list<int>: "
              << phoenix::is_std_multimap<ListType>::value << '\n'
              << "\tstd::map<int, int>: "
              << phoenix::is_std_multimap<MapType>::value << '\n'
              << "\tstd::multimap<int, int>: "
              << phoenix::is_std_multimap<MultimapType>::value << '\n'
              << "\tstd::queue<int>: "
              << phoenix::is_std_multimap<QueueType>::value << '\n'
              << "\tstd::vec<int>: "
              << phoenix::is_std_multimap<VecType>::value << '\n';

    std::cout << "Is queue?\n"
              << "\tstd::deque<int>: "
              << phoenix::is_std_queue<DequeType>::value << '\n'
              << "\tstd::list<int>: "
              << phoenix::is_std_queue<ListType>::value << '\n'
              << "\tstd::map<int, int>: "
              << phoenix::is_std_queue<MapType>::value << '\n'
              << "\tstd::multimap<int, int>: "
              << phoenix::is_std_queue<MultimapType>::value << '\n'
              << "\tstd::queue<int>: "
              << phoenix::is_std_queue<QueueType>::value << '\n'
              << "\tstd::vec<int>: "
              << phoenix::is_std_queue<VecType>::value << '\n';

    std::cout << "Is vector?\n"
              << "\tstd::deque<int>: "
              << phoenix::is_std_vector<DequeType>::value << '\n'
              << "\tstd::list<int>: "
              << phoenix::is_std_vector<ListType>::value << '\n'
              << "\tstd::map<int, int>: "
              << phoenix::is_std_vector<MapType>::value << '\n'
              << "\tstd::multimap<int, int>: "
              << phoenix::is_std_vector<MultimapType>::value << '\n'
              << "\tstd::queue<int>: "
              << phoenix::is_std_vector<QueueType>::value << '\n'
              << "\tstd::vec<int>: "
              << phoenix::is_std_vector<VecType>::value << '\n';

}
